{% if host_roles is defined and host_roles|length %}
roles ["{{ host_roles | join('", "')}}"]

{% endif %}
# Avoid running unnecessary services on the Praefect server
gitaly['enable'] = {{ gitaly_enabled }}
gitlab_kas['enable'] = {{ gitlab_kas_enabled }}
consul['enable'] = {{ consul_enable }}
postgresql['enable'] = {{ postgresql_enabled }}
redis['enable'] = {{ redis_enable }}
nginx['enable'] = {{ nginx_enable }}
puma['enable'] = {{ puma_enable }}
sidekiq['enable'] = {{ sidekiq_enable }}
gitlab_workhorse['enable'] = {{ gitlab_workhorse_enable }}
alertmanager['enable'] = {{ alertmanager_enable }}
prometheus['enable'] = {{ prometheus_enable }}

################################################################################
## Praefect configuration
##
################################################################################
praefect['enable'] = true
praefect['configuration'] = {
  listen_addr: '{{ praefect.listen_address }}',
  prometheus_listen_addr: '{{ praefect.prometheus_listen_addr }}',
  prometheus_exclude_database_from_default_metrics: true,

  auth: {
    token: '{{ praefect.auth_token }}'
  },

  database: {
    host: '{{ praefect.database_host }}',
    port: {{ praefect.database_port }},
    user: '{{ praefect.database_user }}',
    password: '{{ praefect.database_password }}',
    dbname: '{{ praefect.database_dbname }}',
    session_pooled: {
      host: '{{ praefect.database_host }}',
      port: {{ praefect.database_port }},
      user: '{{ praefect.database_user }}',
      password: '{{ praefect.database_password }}',
      dbname: '{{ praefect.database_dbname }}',
    },
  },

  virtual_storage: [
    {
      name: 'default',
      node: [
{% for node in groups['gitaly'] %}
        {
          storage: 'gitaly-{{ loop.index }}',
          address: 'tcp://{{ hostvars[node]['ansible_default_ipv4']['address'] }}:{{ gitaly.listen_addr.split(":")[1] }}',
          token: '{{ gitaly_auth_token }}',
        },
{% endfor %}
      ],
    },
  ],
}

# Prevent database migrations from running on upgrade automatically
praefect['auto_migrate'] = {{ praefect.auto_migrate }}
gitlab_rails['auto_migrate'] = {{ db_auto_migrate }}

################################################################################
## Prometheus Node Exporter
##! Docs: https://docs.gitlab.com/ee/administration/monitoring/prometheus/node_exporter.html
################################################################################

node_exporter['enable'] = {{ node_exporter_enable }}
{% if node_exporter_enable == "true" %}
node_exporter['home'] = '{{ node_exporter_home }}'
node_exporter['log_directory'] = '{{ node_exporter_log_directory }}'
node_exporter['flags'] = {
{% for key, value in node_exporter_flags.items() %}
  '{{ key }}' => "{{ value }}"
{% endfor %}
}
node_exporter['env_directory'] = '{{ node_exporter_env_directory }}'
node_exporter['env'] = {
{% for key, value in node_exporter_environment_variables.items() %}
  '{{ key }}' => "{{ value }}"
{% endfor %}
}

##! Advanced settings. Should be changed only if absolutely needed.
node_exporter['listen_address'] = '{{ node_exporter_listen_address }}'
{% endif %}
